%%%%%%%THIS SCRIPT IS DESIGNED TO COMPUTE THE DISTRIBUTION OF ERROR AT TIME
%%%%%%%T BETWEEN A(k,t) AND c_k N_t%%%%%%%%%%%%%%%%
 
%%%%%%%%%DEFINE THE LIFETIME DISTRIBUTION OF THE MODEL%%%%%%%%
mu=makedist('rician',1,1);

%%%%%%%%%DEFINE THE BIRTHRATE OF THE MODEL%%%%%%%%%%%%%%
b=1;

%%%%%%%%%DEFINE THE MUTATION RATE OF THE MODEL%%%%%%%%%%%
theta=3;

%%%%%this next line compute a so-called STModel class object. Such object
%%%%%contain all the parameter of your model (lifetime distribution ect...)
%%%%% In addition, it compute numerical approximation of the scale
%%%%% functions and of other quantities...
 M=STModel(mu,1,3);
 
 
 co=M.computeCov(1,1,20);%%%%%compute the variance of the error between A(1,t) and c_1 N_t

 
 N=10000;%%%%number of simulations
val=zeros(N,5);
val2=zeros(1,N);val3=zeros(N,5);val4=zeros(1,N);c=zeros(1,5);
c(1)=M.computeCK(1);%%%%% compute the constant c_1
c(2)=M.computeCK(2);
c(3)=M.computeCK(3);
c(4)=M.computeCK(4);
c(5)=M.computeCK(5);
alpha=M.getAlpha;%%%%%% this line compute the malthusian parameter of the model
cts=M.evalDLaplaceExpo(alpha);%%%%% this line compute the value of the derivative of the laplace exponent at point alpha
i=1;
tl=10;%%%%% Time
Nt=length(times);


h=waitbar(0,sprintf('Please wait while simulating %d CPP',N));
    
for i=1:N
    
    waitbar(i/N);
    C=M.simCPP(tl);%%%% This simulate of coalescent point process under the model M
        p=C.getSize;%%% This return N_t
        [A,nclonal]=C.getFrequencySpectrum;%%%%% This return the frequency spetrum of the simulated CPP
        LA = length(A);
        for j=1:5
            if LA<j
                a=0;
            else
                a=A(j);
            end
            val(i,j)=cts*exp(-alpha*tl/2)*(a-c(j)*p);
            val3(i,j)=a;
        end
        val4(i)=nclonal;
        val2(i)=p;
        
        i=i+1;
    clear('C');
    
    
end
close(h);
ker=fitdist(val(:,1),'kernel');
x=-5:0.1:5;
plot(x,ker.pdf(x));